/*******************************************************************************
 * Copyright(c) 2021 dongke All rights reserved. / Confidential
 * 类的信息：
 *		1.程序名称：
 *		2.功能描述：新建其他入库
 * 编辑履历：
 *		作者				日期					版本				修改内容
 *		姜永辉	        2024年3月22日		     1.00		   	    一览
 *******************************************************************************/
const mixins = require('@/mixins/index.js')
const Constants = require('@/utils/Constants');
const util = require('@/utils/util.js')
const app = getApp()
Page({
    mixins: [mixins],
    /**
     * 页面的初始数据
     */
    data: {
        purIdArray: '',//来源单id 
        // 弹出按钮
        buttonList: [{
            name: 'merge',
            title: mixins.$t('save')
        }],
        contentList: [{
            code: 'flag',
            title: mixins.$t('antoHandle'),
            type: 'checkbox'
        }, {
            code: 'need',
            title: mixins.$t('totalAmount'),
            type: 'str'
        },
        {
            code: 'amount',
            content: 0,
            type: 'number'
        }],
        btnFormData: null,
        //弹出pop
        popContent: [{
            code: 'itemQty',
            type: 'step',
            title: mixins.$t('count'),
            required: true
        },
        {
            code: 'whId',
            name: 'whName',
            title: mixins.$t('warehouseId'),
            type: 'drop',
            dropType: 'warehouse'
        },
        {
            code: 'skuSpec',
            title: mixins.$t('goodSpec'),
            type: 'str',
            readonly: true,
        },
        {
            code: 'nonStdCode',
            title: mixins.$t('goodsBatch'),
            type: 'str',
        },
        ], 
        cardList: [{
            name: 'main',
            title: mixins.$t('inBoundInfo'),
        },
        {
            name: 'items',
            title: mixins.$t('goodsDetail'),
            info: '(' + mixins.$t('warehousingProcessing') + ')',
            color: '#E4002B',
            itemAmt: 0,
            content:2,
            displayNum: 1
        }, {
            name: 'other',
            title: mixins.$t('otherInfo')
        }
        ],
        contentObj: {
            main: [
                {
                    code: 'intoReason',
                    name: 'intoReasonName',
                    type: 'choose',
                    required: true,
                    urlKey: 'chooseStorageInReason',
                    urlKeyParam: Constants.kindCode.basicEnter
                },
                {
                    code: 'staffId',
                    name: 'staffName',
                    title: mixins.$t('responsiblePerson'),
                    type: 'choose',
                    required: true,
                    urlKey: 'chooseStaff'
                }, {
                    code: 'orgId',
                    name: 'orgName',
                    title: mixins.$t('orgId'),
                    type: 'choose',
                    required: true,
                    urlKey: 'chooseOrg'
                },
                {
                    code: 'intoDate',
                    name: 'intoDate',
                    type: 'date',
                    required: true,
                },
                {
                    code: 'intoObject',
                    name: 'intoObjectName',
                    title: mixins.$t('inObject'),
                    type: 'choose',
                    urlKey: 'chooseStorageObject'
                },
            ],

            items: [{
                code: 'collectType',
                name: 'collectName',
                type: 'drop',
                dropType: 'collect'
            }, {
                code: 'collectAmount',
                type: 'number',
                title: mixins.$t('totalAmount'),
            }],

            other: [{
                code: 'remarks',
                type: 'textarea',
                title: mixins.$t('remarks'),
                readonly: false
            }, {
                code: 'file',
                type: 'uploader',
                title: mixins.$t('uploader')
            }]
        },
        // 路由
        routeObjName: 'inboundOther',
        table: Constants.tables.inbound,

    },

    /**
   * @desc : 页面加载数据方法
   * @date : 2024/2/1 15:49
   * @author : 姜永辉
   */
    loadInit() {
        if (this.data.formMode == Constants.formMode.edit) {
            wx.setNavigationBarTitle({
                title: mixins.$t('editOtherInWh'),
            })
        } else {
            wx.setNavigationBarTitle({
                title: mixins.$t('addOtherInWh'),
            })
            // 新增
            if (this.data.formData == '{}') {
                this.setData({
                    formData: JSON.stringify({ intoDate: new Date().toDateStr() })
                })
            }
        }
    },

    /**
    * @desc : 给表单赋值
    * @date : 2024/2/1 15:49
    * @author : 姜永辉
    */
    setValuesByEdit(data) {
        let cardList_ = this.data.cardList
        let contentList_ = this.data.contentList
        let sumitemAmt = 0
        let formType = this.data.formType
        //  入库状态-已入库
        if (data.intoStatus == Constants.intoStatus.inBounded) {
            //查询采购订单表 未入库的 详细 
            this.setData({
                buttonList: [{
                    name: 'merge',
                    title: mixins.$t("close")
                }],
            })
        } else {
            this.setData({
                buttonList: [{
                    name: 'merge',
                    title: mixins.$t("inProcessing")
                }],
            })
        }
        sumitemAmt = Number(data.intoingQty) * Number(data.intoingAmt)
        cardList_.forEach(card => {
            if (card.name === 'items') {
                if (formType == 1) {
                    card.info = "（" + mixins.$t("warehousingProcessing") + "）"
                    card.color = "#E4002B"
                } else {
                    card.info = "（" + mixins.$t("checkined") + "）"
                    card.color = "#1B365D"
                }
                card.itemAmt = sumitemAmt
            }
        })
        contentList_[1].content = sumitemAmt

        // 明细的最大入库办理的量
        data.goodsList.forEach(element => {
            if (this.data.item.intoType == Constants.intoType.saleReturn) {
                element['intoingQty_max'] = -1
                element['intoingQty_min'] = -1 * Math.abs(element.intoingQty)
            } else {
                element['intoingQty_max'] = element.intoingQty
                element['intoingQty_min'] = 1
            }
        })

        // 刷新商品明细 显示 查看更多
        let card = this.data.cardList.filter(it => it.name == 'items');
        this.selectComponent('#' + this.data.formName).handleContentObj(card[0])

        this.setData({
            itemData: data,
            cardList: cardList_,
            contentList: contentList_,
            formData: JSON.stringify(data),
            sumitemAmt
        })

    },

    /**
     * @desc   : 绑定数据-选择页面返回的逻辑处理
     * @author : 姜永辉
     * @date   : 2024年3月12日
     */
    chooseData(e) {
        let formData = JSON.parse(this.data.formData)
        let code = e.detail.code
        let data = e.detail.data.data

        if (code == "staffId") { //员工
            formData.staffId = data.id
            formData.staffName = data.name
            formData.orgId = data.orgId
            formData.orgName = data.orgName
        }
        if (code == "orgId") { //部门
            formData.orgId = data.id
            formData.orgName = data.name
        }
        if (code == "intoReason") { //入库原因
            formData.intoReason = data.id
            formData.intoReasonName = data.name
        }
        if (code == "intoObject") { //入库对象
            formData.intoObject = data.id
            formData.intoObjectName = data.name
            formData.objType = data.objType
        }
        this.setData({
            formData: JSON.stringify(formData)
        })
    },

    /**
     * @desc : 外露设置产品方法 
     * @date : 2024/2/1 15:49
     * @author : 姜永辉
     */
    setGoods(e) {
        let contentList_ = this.data.contentList
        let cardList = this.data.cardList
        let formData = JSON.parse(this.data.formData)
        let totalAmout = Number(0)
        // 各个明细的金额数量
        formData.goodsList.forEach(element => {  //循环出商品总共价格 
            element.intoingAmt = element.pricePurchase * element.itemQty
            element.intoingQty = element.itemQty
            element.pricePur = element.pricePurchase
            element.priceInto = element.pricePurchase
            element.intoAmt = 0     //  已入库金额
            element.intoQty = 0     //  已入库数量
            totalAmout += Number(element.pricePurchase * element.itemQty)
        })
        // 左下角的合计金额
        contentList_.forEach(card => {
            if (card.code === 'amount') {
                card.content = totalAmout
            }
        })
        // 明细的合计金额
        cardList.forEach(card => {  //循环出商品总共价格
            if (card.name === 'items') {
                //合计金额
                card.itemAmt = totalAmout
            }
        })
        this.setData({
            contentList: contentList_,
            cardList,
            formData: JSON.stringify(formData)
        })
    },

    /**
     * @desc : 保存数据服务--校验
     * @date : 2024/2/1 15:49
     * @author : 姜永辉
     */
    validData() {
        let formData = JSON.parse(this.data.formData)
        if (formData.goodsList == null || formData.goodsList.length == 0) {
            util.showToast(mixins.$t("chooseGoodsInfo"));
            return false
        }
        // 明细的数量和仓库不能为空
        for (let index = 0; index < formData.goodsList.length; index++) {
            const element = formData.goodsList[index];
            if (element.whId == null) {
                util.showToast(mixins.$t("chooseWh"));
                return false
            }
            if (element.itemQty == null || element.itemQty == '' || element.itemQty == 0) {
                util.showToast(mixins.$t("inputWords") + "[" + element.skuCode + "]" + mixins.$t("count"));
                return false
            }
        }
        return true
    },

    /**
     * @desc : 保存的參數設置
     * @date : 2024/2/1 15:49
     * @author : 姜永辉
     */
    setParams(params) {
        let btnFormData = this.data.btnFormData ? JSON.parse(this.data.btnFormData) : ''
        let formData = JSON.parse(this.data.formData)
        // 新增编辑的
        params.intoId = formData.intoId
        // 总单的 入库中数量和金额合计
        params.intoingAmt = formData.goodsList.sum("intoingAmt")   //金额
        params.intoingQty = formData.goodsList.sum("intoingQty")     //一共的商品数量
        params.intoAmt = 0     //  已入库金额
        params.intoQty = 0     //  已入库数量         
        params.flgAutoHandle = btnFormData ? btnFormData.flag : false //自动出入库标识      
        params.orgId = formData.orgId  //组织部门
        params.staffId = formData.staffId  // 员工
        //  // 供应商1 客户2 所有 传空
        if (formData.objType == 1) {
            params.supId = formData.intoObject  // 供应商
        }
        if (formData.objType == 2) {
            params.cusId = formData.intoObject  // 客户
        }
        // params.whId = formData.whId  // 仓库
        params.remarks = formData.remarks  // 备注
        params.makeStaff = app.globalData.user.staffId  // 制单人
        // 明细的顺序
        let i = 0
        formData.goodsList.forEach(it => {
            it.itemIndex = (i++)
        })
        params.itemList = formData.goodsList //商品明细
        params.annexPaths = formData.annexPaths || [] //附件 
        return params
    },

    /**
    * @desc : 保存数据服务
    * @date : 2024/2/1 15:49
    * @author : 姜永辉
    */
    saveData() {
        if (this.data.formMode == Constants.formMode.edit) {
            return this.excute(this.data.service, this.data.service.otherInboundUpdate, this.data.params)
        } else {
            return this.excute(this.data.service, this.data.service.otherInboundInsert, this.data.params)
        }

    },




})